package 
{
	import flash.display.MovieClip;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	
	import starling.core.Starling;

	[SWF(frameRate = "60", backgroundColor = "#080808")]
	public class StarlingParticlesFire extends MovieClip
	{

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function StarlingParticlesFire()
		{
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;

			Starling.handleLostContext = true;
			star = new Starling(FireView, stage, null, null);
			star.enableErrorChecking = false;
			star.showStatsAt("right", "top", 2);
			star.start();
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		private var star:Starling;
	}
}

import flash.geom.Rectangle;

import starling.core.Starling;
import starling.display.Image;
import starling.display.Sprite;
import starling.events.Event;
import starling.events.ResizeEvent;
import starling.events.Touch;
import starling.events.TouchEvent;
import starling.extensions.PDParticleSystem;
import starling.textures.Texture;

internal class FireView extends Sprite
{

	//----------------------------------------------------------
	//
	//   Constructor 
	//
	//----------------------------------------------------------

	public function FireView()
	{
		addEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
	}

	//----------------------------------------------------------
	//
	//   Property 
	//
	//----------------------------------------------------------

	[Embed(source = "assets_2/bg.png")]
	private var BackgroundImage:Class;

	[Embed(source = "assets_2/particle.pex", mimeType = "application/octet-stream")]
	private var ParticleData:Class;

	[Embed(source = "assets_2/texture.png")]
	private var ParticleImage:Class;

	private var bg:Image;

	private var particles:PDParticleSystem;

	//----------------------------------------------------------
	//
	//   Function 
	//
	//----------------------------------------------------------

	private function addedToStageHandler(event:Event):void
	{
		// bg
		bg = Image.fromBitmap(new BackgroundImage());
		bg.width = stage.stageWidth;
		bg.height = stage.stageHeight;
		addChild(bg);

		// particles
		particles = new PDParticleSystem(
			XML(new ParticleData()),
			Texture.fromBitmap(new ParticleImage()));

		particles.start();
		Starling.juggler.add(particles);
		addChild(particles);

		stage.addEventListener(TouchEvent.TOUCH, stage_touchHandler);
		stage.addEventListener(ResizeEvent.RESIZE, stage_resizeHandler);
	}

	private function stage_resizeHandler(event:ResizeEvent):void
	{
		Starling.current.viewPort = new Rectangle(0, 0, event.width, event.height);
		stage.stageWidth = event.width;
		stage.stageHeight = event.height;

		bg.width = event.width;
		bg.height = event.height;
	}

	private function stage_touchHandler(event:TouchEvent):void
	{
		var touch:Touch = event.getTouch(stage);
		particles.emitterX = touch.globalX;
		particles.emitterY = touch.globalY;
	}
}

